#!/usr/bin/python

import gconf
import os.path
import sys

from gettext import gettext as _
import gettext

#FIXME: add checks here and run without UI if that fails to import
import pygtk
pygtk.require('2.0')
import gtk

def error(primary, secondary):
    d = gtk.MessageDialog(type=gtk.MESSAGE_ERROR, buttons=gtk.BUTTONS_OK)
    d.set_markup("<b><big>%s</big></b>" % primary)
    d.format_secondary_text(secondary)
    d.run()
    d.destroy()
    
def info(primary, secondary):
    d = gtk.MessageDialog(type=gtk.MESSAGE_INFO, buttons=gtk.BUTTONS_OK)
    d.set_markup("<b><big>%s</big></b>" % primary)
    d.format_secondary_text(secondary)
    d.run()
    d.destroy()
    

if __name__ == "__main__":
    gettext.bindtextdomain("gnome-panel")

    client = gconf.client_get_default()
    objects = client.all_dirs("/apps/panel/objects")

    logout=None
    for d in objects:
        if client.get_string(os.path.join(d,"action_type")) == "logout":
            logout=os.path.basename(d)
            break

    # we do not have a logout object or in a non-standard location, fail
    if not logout:
        error(_("No logout button found"),
              _("The logout button can not be found or it is not in "
                "the standard location. Please update the panel "
                "configuration manually."))
        sys.exit(1)

    # remove the logout button
    l=client.get_list("/apps/panel/general/object_id_list", gconf.VALUE_STRING)
    l.remove(logout)
    client.set_list("/apps/panel/general/object_id_list", gconf.VALUE_STRING, l)

    # move the fusa applet to new location
    applets = client.all_dirs("/apps/panel/applets")
    for d in applets:
        if (client.get_string(os.path.join(d,"bonobo_iid")) == "OAFIID:GNOME_FastUserSwitchApplet"):
            client.set_int(os.path.join(d,"position"),0)
            client.set_bool(os.path.join(d,"panel_right_stick"), True)
            break
    else:
        error(_("No fast-user-switching applet found"),
              _("The fusa applet can not be found or it is not in "
                "the standard location. Please update the panel "
                "configuration manually."))
    
    # show nice information
    info(_("Configuration updated"),
         _("Your panel configuration is updated. Please logout "
           "to complete the update."))

